diff -urN --exclude .git --exclude po/ --exclude '*.pyc' --exclude '.*.swp' anaconda/storage/__init__.py anaconda-storage/storage/__init__.py
--- anaconda/storage/__init__.py	1969-12-31 18:00:00.000000000 -0600
+++ anaconda-storage/storage/__init__.py	2009-02-17 13:10:54.000000000 -0600
@@ -0,0 +1,1202 @@
+# __init__.py
+# Entry point for anaconda's storage configuration module.
+#
+# Copyright (C) 2009  Red Hat, Inc.
+#
+# This copyrighted material is made available to anyone wishing to use,
+# modify, copy, or redistribute it subject to the terms and conditions of
+# the GNU General Public License v.2, or (at your option) any later version.
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY expressed or implied, including the implied warranties of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
+# Public License for more details.  You should have received a copy of the
+# GNU General Public License along with this program; if not, write to the
+# Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.  Any Red Hat trademarks that are incorporated in the
+# source code or documentation are not subject to the GNU General Public
+# License and may only be used or replicated with the express permission of
+# Red Hat, Inc.
+#
+# Red Hat Author(s): Dave Lehman <dlehman@redhat.com>
+#
+
+import os
+import time
+
+import sys
+sys.path.append("formats")
+
+if __name__ == "__main__":
+    import storage_log
+
+import iutil
+from partedUtils import getReleaseString, productMatches
+from errors import *
+from devices import *
+from deviceaction import *
+from deviceformat import getFormat
+
+import gettext
+_ = lambda x: gettext.ldgettext("anaconda", x)
+
+import logging
+log = logging.getLogger("storage")
+
+class Storage(object):
+    def __init__(self, anaconda):
+        self.anaconda = anaconda
+
+        # storage configuration variables
+        self.ignoredDisks = []
+        self.exclusiveDisks = []
+        self.doAutoPart = None
+        self.clearPartType = None
+        self.clearPartDisks = []
+        self.encryptedAutoPart = None
+        self.encryptionPassphrase = None
+        self.encryptionRetrofit = None
+        self.reinitializeDisks = None
+        self.zeroMBR = None
+        self.protectedPartitions = []
+
+        self._nextID = 0
+        self.defaultFSType = get_default_filesystem_type()
+
+        self.reset()
+
+    @property
+    def nextID(self):
+        id = self._nextID
+        self._nextID += 1
+        return id
+
+    def reset(self):
+        """ Reset storage configuration to reflect actual system state.
+
+            This should rescan from scratch but not clobber user-obtained
+            information like passphrases, iscsi config, &c
+
+        """
+        self.devicetree = DeviceTree(self.anaconda)
+        self.fsset = FSSet(self.devicetree)
+
+    @property
+    def disks(self):
+        """ A list of the disks in the device tree.
+
+            Ignored disks are not included.
+
+            This is based on the current state of the device tree and
+            does not necessarily reflect the actual on-disk state of the
+            system's disks.
+        """
+        disks = self.devicetree.getDevicesByType("disk")
+        disks.sort(key=lambda d: d.name)
+        return disks
+
+    @property
+    def partitions(self):
+        """ A list of the partitions in the device tree.
+
+            This is based on the current state of the device tree and
+            does not necessarily reflect the actual on-disk state of the
+            system's disks.
+        """
+        partitions = self.devicetree.getDevicesByType("partition")
+        partitions.sort(key=lambda d: d.name)
+        return partitions
+
+    @property
+    def vgs(self):
+        """ A list of the LVM Volume Groups in the device tree.
+
+            This is based on the current state of the device tree and
+            does not necessarily reflect the actual on-disk state of the
+            system's disks.
+        """
+        vgs = self.devicetree.getDevicesByType("lvmvg")
+        vgs.sort(key=lambda d: d.name)
+        return vgs
+
+    @property
+    def lvs(self):
+        """ A list of the LVM Logical Volumes in the device tree.
+
+            This is based on the current state of the device tree and
+            does not necessarily reflect the actual on-disk state of the
+            system's disks.
+        """
+        lvs = self.devicetree.getDevicesByType("lvmlv")
+        lvs.sort(key=lambda d: d.name)
+        return lvs
+
+    @property
+    def pvs(self):
+        """ A list of the LVM Physical Volumes in the device tree.
+
+            This is based on the current state of the device tree and
+            does not necessarily reflect the actual on-disk state of the
+            system's disks.
+        """
+        devices = self.devicetree.devices.values()
+        pvs = [d for d in devices if d.format.type == "lvmpv"]
+        pvs.sort(key=lambda d: d.name)
+        return pvs
+
+    def unusedPVs(self, vg=None):
+        unused = []
+        for pv in self.pvs:
+            used = False
+            for _vg in self.vgs:
+                if _vg.dependsOn(pv) and _vg != vg:
+                    used = True
+                    break
+                elif _vg == vg:
+                    break
+            if not used:
+                unused.append(pv)
+        return unused
+
+    @property
+    def mdarrays(self):
+        """ A list of the MD arrays in the device tree.
+
+            This is based on the current state of the device tree and
+            does not necessarily reflect the actual on-disk state of the
+            system's disks.
+        """
+        arrays = self.devicetree.getDevicesByType("mdarray")
+        arrays.sort(key=lambda d: d.name)
+        return arrays
+
+    @properties
+    def mdmembers(self):
+        """ A list of the MD member devices in the device tree.
+
+            This is based on the current state of the device tree and
+            does not necessarily reflect the actual on-disk state of the
+            system's disks.
+        """
+        devices = self.devicetree.devices.values()
+        members = [d for d in devices if d.format.type == "mdmember"]
+        members.sort(key=lambda d: d.name)
+        return members
+
+    def unusedMDMembers(self, array=None):
+        unused = []
+        for member in self.mdmembers:
+            used = False
+            for _array in self.mdarrays:
+                if _array.dependsOn(member) and _array != array:
+                    used = True
+                    break
+                elif _array == array:
+                    break
+            if not used:
+                unused.append(member)
+        return unused
+
+    def unusedMDMinors(self):
+        """ Return a list of unused minors for use in RAID. """
+        raidMinors = range(0,32)
+        for array in self.mdarrays:
+            if array.minor is not None:
+                raidMinors.remove(array.minor)
+        return raidMinors
+
+    def exceptionDisks(self):
+        """ Return a list of removable devices to save exceptions to.
+
+            FIXME: This raises the problem that the device tree can be
+                   in a state that does not reflect that actual current
+                   state of the system at any given point.
+
+                   We need a way to provide direct scanning of disks,
+                   partitions, and filesystems without relying on the
+                   larger objects' correctness.
+        """
+        dests = []
+        for device in self.devicetree.devices.values():
+            if not device.removable:
+                continue
+
+            dev = parted.Device(path=device.path)
+            disk = parted.Disk(device=dev)
+            for part in disk.partitions:
+                if part.active and \
+                   not part.getFlag(parted.PARTITION_RAID) and \
+                   not part.getFlag(parted.PARTITION_LVM) and \
+                   part.fileSystemType in ("ext3", "ext2", "fat16", "fat32"):
+                    dests.append(part.path, device.name)
+
+            if not parts:
+                dests.append(device.path, device.name)
+
+        return dests
+
+    def deviceImmutable(self, device):
+        """ Return any reason the device cannot be modified/removed.
+
+            Return False if the device can be removed.
+
+            Devices that cannot be removed include:
+
+                - protected partitions
+                - devices that are part of an md array or lvm vg
+                - extended partition containing logical partitions that
+                  meet any of the above criteria
+
+        """
+        if not isinstance(device, Device):
+            raise ValueError("arg1 (%s) must be a Device instance" % device)
+
+        if device.name in self.protectedPartitions:
+            return _("This partition is holding the data for the hard "
+                      "drive install.")
+        elif device.type == "partition" and device.isProtected:
+            # LDL formatted DASDs always have one partition, you'd have to
+            # reformat the DASD in CDL mode to get rid of it
+            return _("You cannot delete a partition of a LDL formatted "
+                     "DASD.")
+        elif device.format.type == "mdmember":
+            mdarrays = devicetree.getDevicesByType("mdarray")
+            for array in mdarrays:
+                if array.dependsOn(device):
+                    if array.minor is not None:
+                        return _("This device is part of the RAID "
+                                 "device %.") % (array.path,)
+                    else:
+                        return _("This device is part of a RAID device.")
+        elif device.format.type == "lvmpv":
+            vgs = devicetree.getDevicesByType("lvmvg")
+            for vg in vgs:
+                if vg.dependsOn(device):
+                    if vg.name is not None:
+                        return _("This device is part of the LVM "
+                                 "volume group '%s'.") % (vg.name,)
+                    else:
+                        return _("This device is part of a LVM volume "
+                                 "group.")
+        elif device.type == "partition" and device.isExtended:
+            reasons = {}
+            for dep in self.devicetree.getDependentDevices(device):
+                reason = self.deviceImmutable(dep)
+                if reason:
+                    reasons[dep.path] = reason
+            if reasons:
+                msg =  _("This device is an extended partition which "
+                         "contains logical partitions that cannot be "
+                         "deleted:\n\n")
+                for dev in reasons:
+                    msg += "%s: %s" % (dev, reasons[dev])
+                return msg
+
+        return False
+
+    def deviceDeps(self, device):
+        return self.devicetree.getDependentDevices(device)
+
+    def newPartition(self):
+        """ Return a new PartitionDevice instance ready for configuring. """
+        return PartitionDevice("req%d" % self.nextID,
+                               format=getFormat(self.defaultFSType),
+                               size=200,
+                               exists=False)
+
+    def createDevice(self, device):
+        """ Schedule creation of a device. """
+        action = ActionCreateDevice(device)
+        self.devicetree.registerAction(action)
+
+    def deleteDevice(self, device):
+        """ Schedule deletion of a device. """
+        action = ActionDestroyDevice(device)
+        self.devicetree.registerAction(action)
+
+    def formatDevice(self, device, format):
+        """ Schedule formatting of a device. """
+        self.devicetree.registerAction(ActionDestroyFormat(device))
+        self.devicetree.registerAction(ActionCreateFormat(device, format))
+
+    def formatByDefault(self, device):
+        """Return whether the device should be reformatted by default."""
+        formatlist = ['/boot', '/var', '/tmp', '/usr']
+        exceptlist = ['/home', '/usr/local', '/opt', '/var/www']
+
+        if not device.format.linuxNative:
+            return False
+
+        if device.format.mountable:
+            if device.format.mountpoint == "/" or \
+               device.format.mountpoint in formatlist:
+                return True
+
+            for p in formatlist:
+                if device.format.mountpoint.startswith(p):
+                    for q in exceptlist:
+                        if device.format.mountpoint.startswith(q):
+                            return False
+                    return True
+        elif device.format.type == "swap":
+                return True
+
+        # be safe for anything else and default to off
+        return False
+
+    def extendedPartitionsSupported(self):
+        for disk in self.disks:
+            if disk.partedDisk.supportsFeature(parted.DISK_TYPE_EXTENDED):
+                return True
+        return False
+
+ def findExistingRootDevices(anaconda, upgradeany=False):
+    """ Return a list of all root filesystems in the device tree. """
+    # XXX these imports will eventually go at the top
+    rootDevs = []
+
+    if not os.path.exists(anaconda.rootPath):
+        iutil.mkdirChain(anaconda.rootPath)
+
+    roots = []
+    for device in anaconda.id.storage.devicetree.leaves:
+        if not device.format.linuxNative or not device.format.mountable:
+            continue
+
+        # FIXME: handle the case of device already mounted on /mnt/isodir
+
+        try:
+            device.setup()
+        except Exception as e:
+            log.warning("setup of %s failed: %s" % (device.name, e))
+            continue
+
+        try:
+            device.format.mount(options="ro", mountpoint=anaconda.rootPath)
+        except Exception as e:
+            log.warning("mount of %s as %s failed: %s" % (device.name,
+                                                          device.format.type,
+                                                          e))
+            device.teardown()
+            continue
+
+        if os.access(anaconda.rootPath + "/etc/fstab", os.R_OK):
+            relstr = getReleaseString(anaconda.rootPath)
+            if upgradeany or productMatches(relstr, productName):
+                rootDevs.append((device.path, relstr))
+
+        # this handles unmounting the filesystem
+        device.teardown(recursive=True)
+
+    return rootDevs
+
+def mountExistingSystem(anaconda, rootDevice, fsset,
+                        allowDirty=None, warnDirty=None,
+                        readOnly=None):
+    """ Mount filesystems specified in rootDevice's /etc/fstab file. """
+    rootPath = anaconda.rootPath
+    if readOnly:
+        readOnly = "ro"
+    else:
+        readOnly = ""
+
+    if rootDevice.path in anaconda.id.storage.protectedPartitions and \
+       os.path.ismount("/mnt/isodir"):
+        # XXX should we add fs.BindFS?
+        isys.mount("/mnt/isodir",
+                   rootPath,
+                   fstype=rootDevice.format.type,
+                   bindMount=True)
+    else:
+        rootDevice.setup()
+        rootDevice.format.mount(chroot=rootPath,
+                                mountpoint="/",
+                                options=readOnly)
+
+    fsset.parseFSTab(chroot=rootPath)
+
+    # check for dirty filesystems
+    dirtyDevs = []
+    for device in fsset.devices:
+        if device.format.type != "ext2":
+            continue
+
+        try:
+            device.setup()
+        except DeviceError as e:
+            # we'll catch this in the main loop
+            continue
+
+        if isys.ext2IsDirty(device.path):
+            log.info("%s contains a dirty ext2 filesystem" % device.path)
+            dirtyDevs.append(device.path)
+
+    messageWindow = anaconda.intf.messageWindow
+    if not allowDirty and dirtyDevs:
+        messageWindow(_("Dirty File Systems"),
+                      _("The following file systems for your Linux system "
+                        "were not unmounted cleanly.  Please boot your "
+                        "Linux installation, let the file systems be "
+                        "checked and shut down cleanly to upgrade.\n"
+                        "%s") % "\n".join(dirtyDevs))
+        anaconda.id.storage.devicetree.teardownAll()
+        sys.exit(0)
+    elif warnDirty and dirtyDevs:
+        rc = messageWindow(_("Dirty File Systems"),
+                           _("The following file systems for your Linux "
+                             "system were not unmounted cleanly.  Would "
+                             "you like to mount them anyway?\n"
+                             "%s") % "\n".join(dirtyDevs),
+                             type = "yesno")
+        if rc == 0:
+            return -1
+
+    if flags.setupFilesystems:
+        fsset.mountFilesystems(anaconda, readOnly=readOnly, skipRoot=True)
+
+
+class BlkidTab(object):
+    """ Dictionary-like interface to blkid.tab with device path keys """
+    def __init__(self, chroot=""):
+        self.chroot = chroot
+        self.devices = {}
+
+    def parse(self):
+        path = "%s/etc/blkid/blkid.tab" % self.chroot
+        log.debug("parsing %s" % path)
+        with open(path) as f:
+            for line in f.readlines():
+                # this is pretty ugly, but an XML parser is more work than
+                # is justifiable for this purpose
+                if not line.startswith("<device "):
+                    continue
+
+                line = line[len("<device "):-len("</device>\n")]
+                (data, sep, device) = line.partition(">")
+                if not device:
+                    continue
+
+                self.devices[device] = {}
+                for pair in data.split():
+                    try:
+                        (key, value) = pair.split("=")
+                    except ValueError:
+                        continue
+
+                    self.devices[device][key] = value[1:-1] # strip off quotes
+
+    def __getitem__(self, key):
+        return self.devices[key]
+
+    def get(self, key, default=None):
+        return self.devices.get(key, default)
+
+        
+class CryptTab(object):
+    """ Dictionary-like interface to crypttab entries with map name keys """
+    def __init__(self, devTree, blkidTab=None):
+        self.devTree = devTree
+        self.blkidTab = blkidTab
+        self.chroot = chroot
+        self.mappings = {}
+
+    def parse(self, chroot=""):
+        """ Parse /etc/crypttab from an existing installation. """
+        if not chroot or not os.path.isdir(chroot):
+            chroot = ""
+
+        path = "%s/etc/crypttab" % chroot
+        log.debug("parsing %s" % path)
+        with open(path) as f:
+            for line in f.readlines():
+                if not self.blkidTab:
+                    try:
+                        self.blkidTab = BlkidTab(chroot=chroot)
+                        self.blkidTab.parse()
+                    except Exception:
+                        self.blkidTab = None
+
+                for line in lines:
+                    (line, pound, comment) = line.partition("#")
+                    fields = line.split()
+                    if not 2 <= len(fields) <= 4:
+                        continue
+                    elif len(fields) == 2:
+                        fields.extend(['none', ''])
+                    elif len(fields) == 3:
+                        fields.append('')
+
+                    (name, devspec, keyfile, options) = fields
+
+                    # resolve devspec to a device in the tree
+                    device = resolveDevice(self.devTree,
+                                           devspec,
+                                           blkidTab=self.blkidTab)
+                    if device:
+                        self.mappings[name] = {"device": device,
+                                               "keyfile": keyfile,
+                                               "options": options}
+
+    def populate(self):
+        """ Populate the instance based on the device tree's contents. """
+        for device in self.devTree:
+            # XXX should we put them all in there or just the ones that
+            #     are part of a device containing swap or a filesystem?
+            #
+            #       Put them all in here -- we can filter from FSSet
+            if device.format.type != "luks":
+                continue
+
+            key_file = device.format.keyFile
+            if not key_file:
+                key_file = "none"
+
+            options = device.format.options
+            if not options:
+                options = ""
+
+            self.mappings[device.format.mapName] = {"device": device,
+                                                    "keyfile": key_file,
+                                                    "options": options}
+
+    def crypttab(self):
+        """ Write out /etc/crypttab """
+        crypttab = ""
+        for name in self.mappings:
+            entry = self[name]
+            crypttab += "%s UUID=%s %s %s" % (name,
+                                              entry['device'].format.uuid,
+                                              entry['keyfile'],
+                                              entry['options'])
+        return crypttab                       
+
+    def __getitem__(self, key):
+        return self.mappings[key]
+
+    def get(self, key, default=None):
+        return self.mappings.get(key, default)
+
+def fstab_entry_get_field(entry, fieldname):
+    index = fstab_fields[fieldname]
+    return entry[index]
+
+def get_containing_device(path, devicetree):
+    """ Return the device that a path resides on. """
+    if not os.path.exists(path):
+        return None
+
+    st = os.stat(path)
+    major = os.major(st.st_dev)
+    minor = os.minor(st.st_dev)
+    link = "/sys/dev/block/%s:%s" % (major, minor)
+    if not os.path.exists(link):
+        return None
+
+    try:
+        device_name = os.path.basename(os.readlink(link))
+    except Exception:
+        return None
+
+    return devicetree.getDeviceByName(device_name)
+
+
+class FSSet(object):
+    """ A class to represent a set of filesystems. """
+    def __init__(self, devTree):
+        self.devices = []
+        self.devTree = devTree
+        self.cryptTab = None
+        self.blkidTab = None
+
+    def parseFSTab(self, chroot=""):
+        """ parse /etc/fstab
+
+            preconditions:
+                all storage devices have been scanned, including filesystems
+            postconditions:
+
+            FIXME: control which exceptions we raise
+
+            XXX do we care about bind mounts?
+                how about nodev mounts?
+                loop mounts?
+                nfs?
+        """
+        if not chroot or not os.path.isdir(chroot):
+            chroot = ""
+
+        path = "%s/etc/fstab" % chroot
+        if not os.access(path, os.R_OK):
+            # XXX should we raise an exception instead?
+            log.info("cannot open %s for read" % path)
+            return
+
+        blkidTab = BlkidTab(chroot=chroot)
+        try:
+            blkidTab.parse()
+            log.debug("blkid.tab devs: %s" % blkidTab.devices.keys())
+        except Exception as e:
+            log.info("error parsing blkid.tab: %s" % e)
+            blkidTab = None
+
+        cryptTab = CryptTab(self.devTree, blkidTab=blkidTab)
+        try:
+            cryptTab.parse(chroot=chroot)
+            log.debug("crypttab maps: %s" % cryptTab.mappings.keys())
+        except Exception as e:
+            log.info("error parsing crypttab: %s" % e)
+            cryptTab = None
+
+        self.blkidTab = blkidTab
+        self.cryptTab = cryptTab
+
+        with open(path) as f:
+            log.debug("parsing %s" % path)
+
+            lines = f.readlines()
+
+            # save the original file
+            self.origFStab = ''.join(lines)
+
+            for line in lines:
+                # strip off comments
+                (line, pound, comment) = line.partition("#")
+                fields = line.split()
+
+                if not 4 <= len(fields) <= 6:
+                    continue
+                elif len(fields) == 4:
+                    fields.extend([0, 0])
+                elif len(fields) == 5:
+                    fields.append(0)
+
+                (devspec, mountpoint, fstype, options, dump, passno) = fields
+
+                # find device in the tree
+                device = resolveDevice(self.devTree,
+                                       devspec,
+                                       cryptTab=cryptTab,
+                                       blkidTab=blkidTab)
+                if device:
+                    # fall through to the bottom of this block
+                    pass
+                elif devspec.startswith("/dev/loop"):
+                    # FIXME: WTF do we do with these?
+                elif ":" in devspec:
+                    # NFS -- preserve but otherwise ignore?
+                    fs = getFormat(fstype)
+                    device = NFSDevice(devspec,
+                                       format=getFormat(fstype,
+                                                        device=devspec),
+                                       exists=True)
+                elif devspec.startswith("/") and fstype == "swap":
+                    # swap file?
+                    device = FileDevice(devspec,
+                                        parents=get_containing_device(devspec),
+                                        exists=True)
+                elif fstype == "bind" or "bind" in options:
+                    # bind mount... set fstype so later comparison won't
+                    # turn up false positives
+                    fstype = "bind"
+                    device = FileDevice(devspec,
+                                        parents=get_containing_device(devspec),
+                                        exists=True)
+                    device.setFormat(getFormat("bind",
+                                               device=device.path,
+                                               exists=True))
+                else:
+                    # nodev filesystem -- preserve or drop completely?
+                    fs = getFormat(fstype)
+                    if fs.nodev:
+                        device = NoDevice(fs)
+                    #self.devTree._addDevice(device)
+
+                if device is None:
+                    log.error("failed to resolve %s (%s) from fstab" % (devspec,
+                                                                        fstype))
+                    continue
+
+                # make sure, if we're using a device from the tree, that
+                # the device's format we found matches what's in the fstab
+                fmt = getFormat(fstype, device=device.path)
+                if fmt.type != device.format.type:
+                    log.warning("scanned format (%s) differs from fstab "
+                                "format (%s)" % (device.format.type, fstype))
+
+                if device.format.mountable:
+                    device.format.mountpoint = mountpoint
+                    device.format.mountopts = options
+
+                # is this useful?
+                try:
+                    device.format.options = options
+                except AttributeError:
+                    pass
+
+                self.devices.append(device)
+
+    def fsFreeSpace(self, chroot='/'):
+        space = []
+        for device in self.devices:
+            if not device.format.mountable or \
+               not device.format.status:
+                continue
+
+            path = "%s/%s" % (chroot, device.format.mountpoint)
+            try:
+                space.append((device.format.mountpoint,
+                              isys.pathSpaceAvailable(path)))
+            except SystemError:
+                log.error("failed to calculate free space for %s" % (device.format.mountpoint,))
+
+        space.sort(key=lambda s: s[1])
+        return space
+
+    def mtab(self):
+        format = "%s %s %s %s 0 0\n"
+        mtab = ""
+        for device in self.devices:
+            if not device.format.status:
+                continue
+            if not device.format.mountable:
+                continue
+            if device.format.mountpoint:
+                options = device.format.mountopts
+                options = options.replace("defaults,", "")
+                options = options.replace("defaults", "")
+                if options:
+                    options = "rw," + options
+                else:
+                    options = "rw"
+                mtab = mtab + format % (device.path,
+                                        device.format.mountpoint,
+                                        device.format.type,
+                                        options)
+        return mtab
+
+    def turnOnSwap(self, intf=None, upgrading=None):
+        for device in self.swapDevices:
+            try:
+                device.setup()
+                device.setupFormat()
+            except SuspendError:
+                if intf:
+                    if upgrading:
+                        msg = _("The swap device:\n\n     %s\n\n"
+                                "in your /etc/fstab file is currently in "
+                                "use as a software suspend device, "
+                                "which means your system is hibernating. "
+                                "To perform an upgrade, please shut down "
+                                "your system rather than hibernating it.") \
+                              % device.path)
+                    else:
+                        msg = _("The swap device:\n\n     %s\n\n"
+                                "in your /etc/fstab file is currently in "
+                                "use as a software suspend device, "
+                                "which means your system is hibernating. "
+                                "If you are performing a new install, "
+                                "make sure the installer is set "
+                                "to format all swap devices.") \
+                              % device.path)
+
+                    intf.messageWindow(_("Error"), msg)
+                sys.exit(0)
+            except DeviceError as msg:
+                if intf:
+                    if upgrading:
+                        err = _("Error enabling swap device %s: %s\n\n"
+                                "The /etc/fstab on your upgrade partition "
+                                "does not reference a valid swap "
+                                "device.\n\nPress OK to exit the "
+                                "installer") % (device.path, msg)
+                    else:
+                        err = _("Error enabling swap device %s: %s\n\n"
+                                "This most likely means this swap "
+                                "device has not been initialized.\n\n"
+                                "Press OK to exit the installer.") % \
+                              (device.path, msg)
+                    intf.messageWindow(_("Error"), err)
+                sys.exit(0)
+
+    def mountFilesystems(self, anaconda, raiseErrors=None, readOnly=None,
+                         skipRoot=False):
+        intf = anaconda.intf
+        for device in [d for d in self.devices if d.isleaf]:
+            if not device.format.mountable:
+                continue
+
+            if skipRoot and mountpoint == "/":
+                continue
+
+            if "noauto" in options.split(","):
+                continue
+
+            try:
+                device.setup()
+            except Exception as msg:
+                # FIXME: need an error popup
+                continue
+
+            if readOnly:
+                options = "%s,%s" % (options, readOnly)
+
+            try:
+                device.format.mount(options=options, chroot=anaconda.rootPath)
+            except OSError as (num, msg):
+                if intf:
+                    if num == errno.EEXIST:
+                        intf.messageWindow(_("Invalid mount point"),
+                                           _("An error occurred when trying "
+                                             "to create %s.  Some element of "
+                                             "this path is not a directory. "
+                                             "This is a fatal error and the "
+                                             "install cannot continue.\n\n"
+                                             "Press <Enter> to exit the "
+                                             "installer.") % (mountpoint,))
+                    else:
+                        intf.messageWindow(_("Invalid mount point"),
+                                           _("An error occurred when trying "
+                                             "to create %s: %s.  This is "
+                                             "a fatal error and the install "
+                                             "cannot continue.\n\n"
+                                             "Press <Enter> to exit the "
+                                             "installer.") % (mountpoint,
+                                                              msg))
+                log.error("OSError: (%d) %s" % (num, msg) )
+                sys.exit(0)
+            except SystemError as (num, msg):
+                if raiseErrors:
+                    raise
+                if intf and not device.format.linuxNative:
+                    ret = intf.messageWindow(_("Unable to mount filesystem"),
+                                             _("An error occurred mounting "
+                                             "device %s as %s.  You may "
+                                             "continue installation, but "
+                                             "there may be problems.") %
+                                             (device.path,
+                                              mountpoint),
+                                             type="custom",
+                                             custom_icon="warning",
+                                             custom_buttons=[_("_Exit installer"),
+                                                            _("_Continue")])
+
+                    if ret == 0:
+                        sys.exit(0)
+                    else:
+                        continue
+
+                log.error("SystemError: (%d) %s" % (num, msg) )
+                sys.exit(0)
+            except FSError as msg:
+                if intf:
+                    intf.messageWindow(_("Unable to mount filesystem"),
+                                       _("An error occurred mounting "
+                                         "device %s as %s: %s. This is "
+                                         "a fatal error and the install "
+                                         "cannot continue.\n\n"
+                                         "Press <Enter> to exit the "
+                                         "installer.") % (mountpoint,
+                                                          msg))
+                log.error("FSError: %s" % msg)
+                sys.exit(0)
+
+    def umountFilesystems(self, instPath, ignoreErrors=True, swapoff=True):
+        # XXX if we tracked the /dev bind mount this wouln't be necessary
+        if os.path.ismount("%s/dev" % instPath):
+            isys.umount("%s/dev" % instPath, removeDir=0)
+
+        # reverse works in place so we take a slice
+        devices = self.devices[:]
+        devices.reverse()
+        for device in [d for d in devices if d.isleaf]:
+            if not device.format.mountable and \
+               (device.format.type != "swap" or swapoff):
+                continue
+
+            device.teardownFormat()
+            device.teardown()
+
+    def createSwapFile(self, device, rootPath, size):
+        """ Create and activate a swap file under rootPath. """
+        filename = "/SWAP"
+        count = 0   
+        while os.path.exists("%s/%s" % (rootPath, filename) or \
+              self.devTree.getDeviceByName(filename):
+            file = os.path.normpath("%s/%s" % (rootPath, filename))
+            count += 1
+            filename = "/SWAP-%d" % count
+
+        dev = FileDevice(filename,
+                         size=size,
+                         parents=self.rootDevice,
+                         format=getFormat("swap", device=filename))
+        dev.create()
+        dev.createFormat()
+        dev.setup()
+        dev.setupFormat()
+        # nasty, nasty
+        self.devTree._addDevice(dev)
+        self.devices.append(dev)
+
+    def mkDevRoot(self, instPath):
+        root = self.rootDevice
+        dev = "%s/dev/%s" % (instPath, root.device.getDevice())
+        if not os.path.exists("%s/dev/root" %(instPath,)) and os.path.exists(dev):
+            rdev = os.stat(dev).st_rdev
+            os.mknod("%s/dev/root" % (instPath,), stat.S_IFBLK | 0600, rdev)
+
+    @property
+    def swapDevices(self):
+        swaps = []
+        for device in self.devices:
+            if device.format.type == "swap":
+                swaps.append(device)
+        return swaps
+
+    @property
+    def rootDevice(self):
+        for device in self.devices:
+            try:
+                mountpoint = device.format.mountpoint
+            except AttributeError:
+                mountpoint = None
+
+            if mountpoint == "/":
+                return device
+
+    @property
+    def migratableDevices(self):
+        """ Return a list of devices whose filesystems can be migrated. """
+        return []   # no migrate for you!!!
+
+    def write(self, chroot="/"):
+        """ write out all config files based on the set of filesystems """
+        pass
+
+    def crypttab(self):
+        # if we are upgrading, do we want to mess w/ crypttab?
+        # gut reaction says no, but plymouth needs the names to be very
+        # specific for passphrase prompting
+        if not self.cryptTab:
+            self.cryptTab = CryptTab(self.devTree)
+            self.cryptTab.populate()
+
+        # prune crypttab -- only mappings required by one or more entries
+        for name in self.cryptTab.mappings:
+            keep = False
+            mapInfo = self.cryptTab[name]
+            cryptoDev = mapInfo['device']
+            for device in self.devices:
+                if device.dependsOn(cryptoDev):
+                    keep = True
+                    break
+
+            if not keep:
+                del self.cryptTab.mappings[name]
+
+        return self.cryptTab.crypttab()
+
+    def mdadmConf(self):
+        """ Return the contents of mdadm.conf. """
+        arrays = self.devTree.getDevicesByType("mdarray")
+        conf = ""
+        for array in arrays:
+            writeConf = False
+            if array in self.devices:
+                writeConf = True
+            else:
+                for device in self.devices:
+                    if device.dependsOn(array):
+                        writeConf = True
+                        break
+
+            if writeConf:
+                conf += array.mdadmConfEntry
+
+        return conf
+
+    def writeFSTab(self, chroot="/"):
+        """ Write out /etc/fstab. """
+        pass
+
+    def fstab (self):
+        format = "%-23s %-23s %-7s %-15s %d %d\n"
+        fstab = """
+#
+# /etc/fstab
+# Created by anaconda on %s
+#
+# Accessible filesystems, by reference, are maintained under '/dev/disk'
+# See man pages fstab(5), findfs(8), mount(8) and/or vol_id(8) for more info
+#
+""" % time.asctime()
+
+        for device in self.device:
+            # why the hell do we put swap in the fstab, anyway?
+            if not device.format.mountable and device.format.type != "swap":
+                continue
+
+            fstype = device.format.type
+            if fstype == "swap":
+                mountpoint = "swap"
+                options = device.format.options
+            else:
+                mountpoint = device.format.mountpoint
+                options = gettattr(device.format.mountopts
+                if not mountpoint:
+                    log.warning("%s filesystem on %s has no mountpoint" % \
+                                                            (fstype,
+                                                             device.path))
+                    continue
+
+            if not options:
+                # why not, right?
+                options = "defaults"
+
+            devspec = device.fstabSpec
+            dump = device.format.dump
+            if device.format.check and mountpoint == "/":
+                passno = 1
+            elif device.format.check:
+                passno = 2
+            else:
+                passno = 0
+            fstab = fstab + device.fstabComment
+            fstab = fstab + format % (devspec, mountpoint, fstype,
+                                      options, dump, passno)
+        return fstab
+
+    @property
+    def bootDevice(self):
+        mntDict = {}
+        bootDev = None
+        for device in [d for d in self.devices if d.format.mountable]:
+            mntDict[device.format.mountpoint] = device
+
+        # FIXME: this ppc stuff feels kind of crufty -- the abstraction
+        # here needs a little bit of work
+        if iutil.getPPCMacGen() == "NewWorld":
+            for device in self.devTree.devices.values():
+                # XXX do we need to also check the size?
+                if device.format.type == "hfs" and device.bootable:
+                    bootDev = device
+        elif (iutil.getPPCMachine() == "pSeries" or
+              iutil.getPPCMachine() == "iSeries"):
+            # we want the first prep partition or the first newly formatted one
+            # XXX who cares if PReP is formatted? it has no format.
+            partitions = self.devTree.getDeviceByType("partition")
+            for device in partitions:
+                if device.partedPartition.getFlag(parted.PARTITION_PREP) and \
+                   (bestprep is None or \
+                    (bestprep.format.exists and not device.format.exists)):
+                    bootDev = device
+        elif iutil.isEfi():
+            bootDev = mntDict.get('/boot/efi')
+        else:
+            bootDev = mntDict.get("/boot", mntDict.get("/"))
+
+        # XXX should we raise an error if no boot device was found?
+        return bootDev
+
+    def bootloaderChoices(self, bl):
+        ret = {}
+        bootDev = self.bootDevice
+
+        if bootDev is None:
+            log.warning("no boot device set")
+            return ret
+
+        if iutil.isEfi():
+            ret['boot'] = (bootDev.path, N_("EFI System Partition"))
+        elif bootDev.device.getName() == "RAIDDevice":
+            ret['boot'] = (bootDev.path, N_("RAID Device"))
+            ret['mbr'] = (bl.drivelist[0], N_("Master Boot Record (MBR)"))
+        elif iutil.getPPCMacGen() == "NewWorld":
+            ret['boot'] = (bootDev.path, N_("Apple Bootstrap"))
+            partitions = self.devTree.getDevicesByType("partition")
+            for (n, device) in enumerate(partitions):
+                if (device.format.type == "hfs" and device.bootable and \
+                    device.path != bootDev.path)):
+                    ret['boot%d' %(n,)] = (device.path,
+                                           N_("Apple Bootstrap"))
+        elif (iutil.getPPCMachine() == "pSeries" or
+              iutil.getPPCMachine() == "iSeries"):
+            ret['boot'] = (bootDev.device, N_("PPC PReP Boot"))
+        else:
+            ret['boot'] = (bootDev.device,
+                           N_("First sector of boot partition"))
+            ret['mbr'] = (bl.drivelist[0], N_("Master Boot Record (MBR)"))
+
+        return ret
+
+           
+def resolveDevice(tree, devspec, blkidTab=None, cryptTab=None):
+    # find device in the tree
+    device = None
+    if devspec.startswith("UUID="):
+        # device-by-uuid
+        uuid = devspec.partition("=")[2]
+        device = tree.uuids.get(uuid)
+        if device is None:
+            log.error("failed to resolve device %s" % devspec)
+    elif devspec.startswith("LABEL="):
+        # device-by-label
+        label = devspec.partition("=")[2]
+        device = tree.fslabels.get(label)
+        if device is None:
+            log.error("failed to resolve device %s" % devspec)
+    elif devspec.startswith("/dev/"):
+        # device path
+        device = tree.devices.get(devspec)
+        if device is None:
+            if blkidTab:
+                # try to use the blkid.tab to correlate the device
+                # path with a UUID
+                blkidTabEnt = blkidTab.get(devspec)
+                if blkidTabEnt:
+                    log.debug("found blkid.tab entry for '%s'" % devspec)
+                    uuid = blkidTabEnt.get("UUID")
+                    if uuid:
+                        device = tree.getDeviceByUuid(uuid)
+                        if device:
+                            devstr = device.name
+                        else:
+                            devstr = "None"
+                        log.debug("found device '%s' in tree" % devstr)
+                    if device and device.format and \
+                       device.format.type == "luks":
+                        map_name = device.format.mapName
+                        log.debug("luks device; map name is '%s'" % map_name)
+                        mapped_dev = tree.getDeviceByName(map_name)
+                        if mapped_dev:
+                            device = mapped_dev
+
+            if device is None and cryptTab and \
+               devspec.startswith("/dev/mapper/"):
+                # try to use a dm-crypt mapping name to 
+                # obtain the underlying device, possibly
+                # using blkid.tab
+                cryptTabEnt = cryptTab.get(devspec.split("/")[-1])
+                if cryptTabEnt:
+                    luks_dev = cryptTabEnt['device']
+                    try:
+                        device = tree.getChildren(luks_dev)[0]
+                    except IndexError as e:
+                        pass
+            elif device is None:
+                # dear lvm: can we please have a few more device nodes
+                #           for each logical volume?
+                #           three just doesn't seem like enough.
+                name = devspec[5:]      # strip off leading "/dev/"
+                (vg_name, slash, lv_name) = name.partition("/")
+                if lv_name and not "/" in lv_name:
+                    # looks like we may have one
+                    lv = "%s-%s" % (vg_name, lv_name)
+                    device = tree.getDeviceByName(lv)
+
+    if device:
+        log.debug("resolved '%s' to '%s' (%s)" % (devspec, device.name, device.type))
+    else:
+        log.debug("failed to resolve '%s'" % devspec)
+    return device
+
+
